<?php
/*
Plugin Name: Marketpress Audio Store
Version: 0.3.0
Plugin URI: http://acoustics.pottervilla.com
Description: A Simple plugin that adds some audio related custom fields and a custom Marketpress theme.
Author: Jonathan Potter
Author URI: http://pottervilla.com
License: GPL2
*/

/*
add_action('init', 'pvat_wpml_marketpress_init');

function pvat_wpml_marketpress_init() {
	add_post_type_support( 'product', 'custom-fields' );
}
*/

/* Define the custom box */

add_action( 'add_meta_boxes', 'mp_audio_store_metabox' );

/* Do something with the data entered */
add_action( 'save_post', 'mp_audio_store_save_postdata' );

/* Adds a box to the main column on the product edit screen */
function mp_audio_store_metabox() {
    add_meta_box('mp_audio_store_metabox_id', 'Song/Album Information', 'mp_audio_store_inner_custom_box', 'product', 'normal', 'default');
}

/* Prints the box content */
function mp_audio_store_inner_custom_box( $post ) {

  // Use nonce for verification
  wp_nonce_field( plugin_basename( __FILE__ ), 'mp_audio_store' );

  // The actual fields for data entry
  
  echo '<table>';
  // acoustics_album meta
  $acoustics_album = get_post_meta( $post->ID, 'acoustics_album', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_album">';
  echo  _e("Album");
  echo '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_album" name="mp_audio_store_acoustics_album" value="'.esc_attr($acoustics_album).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> PotterVilla Reflections</span></td></tr>';
  
 // acoustics_artist meta
  $acoustics_artist = get_post_meta( $post->ID, 'acoustics_artist', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_artist">';
  echo  _e("Artist");
  echo  '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_artist" name="mp_audio_store_acoustics_artist" value="'.esc_attr($acoustics_artist).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> Jonathan Potter</td></tr>';
  
  // acoustics_genre meta
  $acoustics_genre = get_post_meta( $post->ID, 'acoustics_genre', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_genre">';
  echo  _e("Genre");
  echo  '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_genre" name="mp_audio_store_acoustics_genre" value="'.esc_attr($acoustics_genre).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> Classical; Easy Listening</span></td></tr>';
      
  // acoustics_year meta
  $acoustics_year = get_post_meta( $post->ID, 'acoustics_year', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_year">';
  echo  _e("Year");
  echo  '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_year" name="mp_audio_store_acoustics_year" value="'.esc_attr($acoustics_year).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> 2013</span></td></tr>';
  
  // acoustics_media meta
  $acoustics_media = get_post_meta( $post->ID, 'acoustics_media', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_media">';
  echo  _e("Media");
  echo  '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_media" name="mp_audio_store_acoustics_media" value="'.esc_attr($acoustics_media).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> MP3 Download (.mp3, 204KB) <strong>OR</strong> CD (Jewel Case)</span></td></tr>';
    
  // acoustics_tracks meta
  $acoustics_tracks = get_post_meta( $post->ID, 'acoustics_tracks', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_tracks">';
  echo  _e("Tracks");
  echo  '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_tracks" name="mp_audio_store_acoustics_tracks" value="'.esc_attr($acoustics_tracks).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> 1 <strong>OR</strong> 12</span></td></tr>';
    
  // acoustics_runtime meta
  $acoustics_runtime = get_post_meta( $post->ID, 'acoustics_runtime', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_runtime">';
  echo  _e("Runtime");
  echo  '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_runtime" name="mp_audio_store_acoustics_runtime" value="'.esc_attr($acoustics_runtime).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> 04:12</span></td></tr>';
     
  //Insert break line
  echo '<tr><td colspan="3" style="padding-top: 10px;"><em>';
  echo 'The next 2 lines of information add tags to the product page when using the Acoustics Marketpress theme. Fill them in to make things look great!';
  echo '</em></td></tr>';
	 
  // acoustics_media_short meta
  $acoustics_media_short = get_post_meta( $post->ID, 'acoustics_media_short', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_media_short">';
  echo  _e("Media (tag)");
  echo  '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_media_short" name="mp_audio_store_acoustics_media_short" value="'.esc_attr($acoustics_media_short).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> MP3 <strong>OR</strong> CD</span></td></tr>';
  
  // acoustics_type meta
  $acoustics_type = get_post_meta( $post->ID, 'acoustics_type', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_type">';
  echo  _e("Type (tag)");
  echo  '</label></td>';
  echo '<td><input type="text" id="mp_audio_store_acoustics_type" name="mp_audio_store_acoustics_type" value="'.esc_attr($acoustics_type).'" size="80" /></td>';
  echo '<td><span style="color: #888;"><strong>Sample:</strong> Single <strong>OR</strong> Album</span></td></tr>';

  
  //Insert break line
  echo '<tr><td colspan="3" style="padding-top: 10px;"><em>';
  echo 'This line is for your mp3 sample file. You\'ll want to put this file somewhere where the public can access it, like the WP uploads directory. I usually take a 30 second clip of the full song. Once the file is uploaded, paste the URL here.';
  echo '</em></td></tr>';
  
  // acoustics_audio_url meta
  $acoustics_audio_url = get_post_meta( $post->ID, 'acoustics_audio_url', true );
  echo '<tr><td><label for="mp_audio_store_acoustics_audio_url">';
  echo  _e("Demo Clip URL");
  echo  '</label></td>';
  echo '<td colspan="2"><input type="text" id="mp_audio_store_acoustics_audio_url" name="mp_audio_store_acoustics_audio_url" value="'.esc_attr($acoustics_audio_url).'" size="120" /></td>';
  echo '</tr><tr><td colspan="3"><span style="color: #888;"><strong>Sample:</strong> http://acoustics.pottervilla.com/wp-content/uploads/demos/01sample.mp3</span></td></tr>';

  echo '</table>';
  }

/* When the post is saved, saves our custom data */
function mp_audio_store_save_postdata( $post_id ) {

  // First we need to check if the current user is authorised to do this action. 
  if ( 'product' == $_POST['post_type'] ) {
    if ( ! current_user_can( 'edit_post', $post_id ) )
        return;
  }
  
  // Secondly we need to check if the user intended to change this value.
  if ( ! isset( $_POST['mp_audio_store'] ) || ! wp_verify_nonce( $_POST['mp_audio_store'], plugin_basename( __FILE__ ) ) )
      return;

  // Thirdly we can save the value to the database
 
  //if saving in a custom table, get post_ID
  $post_ID = $_POST['post_ID'];

  // Add items to database:
  $acoustics_album = sanitize_text_field( $_POST['mp_audio_store_acoustics_album'] );
  add_post_meta($post_ID, 'acoustics_album', $acoustics_album, true) or
    update_post_meta($post_ID, 'acoustics_album', $acoustics_album);
	
  $acoustics_artist = sanitize_text_field( $_POST['mp_audio_store_acoustics_artist'] );
  add_post_meta($post_ID, 'acoustics_artist', $acoustics_artist, true) or
    update_post_meta($post_ID, 'acoustics_artist', $acoustics_artist);
	
  $acoustics_genre = sanitize_text_field( $_POST['mp_audio_store_acoustics_genre'] );
  add_post_meta($post_ID, 'acoustics_genre', $acoustics_genre, true) or
    update_post_meta($post_ID, 'acoustics_genre', $acoustics_genre);
	
  $acoustics_year = sanitize_text_field( $_POST['mp_audio_store_acoustics_year'] );
  add_post_meta($post_ID, 'acoustics_year', $acoustics_year, true) or
    update_post_meta($post_ID, 'acoustics_year', $acoustics_year);
	
  $acoustics_media = sanitize_text_field( $_POST['mp_audio_store_acoustics_media'] );
  add_post_meta($post_ID, 'acoustics_media', $acoustics_media, true) or
    update_post_meta($post_ID, 'acoustics_media', $acoustics_media);

  $acoustics_tracks = sanitize_text_field( $_POST['mp_audio_store_acoustics_tracks'] );
  add_post_meta($post_ID, 'acoustics_tracks', $acoustics_tracks, true) or
    update_post_meta($post_ID, 'acoustics_tracks', $acoustics_tracks);
	
  $acoustics_runtime = sanitize_text_field( $_POST['mp_audio_store_acoustics_runtime'] );
  add_post_meta($post_ID, 'acoustics_runtime', $acoustics_runtime, true) or
    update_post_meta($post_ID, 'acoustics_runtime', $acoustics_runtime);
	
  $acoustics_media_short = sanitize_text_field( $_POST['mp_audio_store_acoustics_media_short'] );
  add_post_meta($post_ID, 'acoustics_media_short', $acoustics_media_short, true) or
    update_post_meta($post_ID, 'acoustics_media_short', $acoustics_media_short);
	
  $acoustics_type = sanitize_text_field( $_POST['mp_audio_store_acoustics_type'] );
  add_post_meta($post_ID, 'acoustics_type', $acoustics_type, true) or
    update_post_meta($post_ID, 'acoustics_type', $acoustics_type);
	
  $acoustics_audio_url = sanitize_text_field( $_POST['mp_audio_store_acoustics_audio_url'] );
  add_post_meta($post_ID, 'acoustics_audio_url', $acoustics_audio_url, true) or
    update_post_meta($post_ID, 'acoustics_audio_url', $acoustics_audio_url);
	

}



//Add shortcode to display product boxes:


function productbox_shortcode($atts, $content = null){
extract(shortcode_atts(array("productid" => '', ), $atts));
$productbox_post = get_post($productid);
$productbox_post->post_title;
if (get_post_meta($productbox_post -> ID, 'acoustics_media_short', True) != ''){
$if_echo_type = '<span class="mp3-label">' . get_post_meta($productbox_post -> ID, 'acoustics_media_short', True) . '</span>&nbsp;';
}else{
$if_echo_type = '';
}

	return '<div class="mp_one_tile mp_thumbnail mp_excerpt" style="float: left;">
<div class="mp_one_product mp_squeeze_block" style="width: 450px;">
<div class="mp_product_detail mp_squeeze_block" style="width: 450px;"><div class="mp_squeeze_image"><p><a class="mp_img_link" id="product_image-60" href="' . get_permalink($productbox_post -> ID) . '">' . get_the_post_thumbnail( $productbox_post -> ID, 'thumbnail', array('class' => 'alignleft mp_product_image_list wp-post-image') ) . '</a></p></div>
<div class="mp_squeeze_text"><h3 class="mp_product_name"><a href="' . get_permalink( $productbox_post->ID ) . '">' . $productbox_post->post_title . '</a></h3>
<p class="mp_excerpt">' . $productbox_post->post_excerpt . '</p> </div>

<div style="float: right; margin-right: 10px;"><div class="mp_squeeze">
' . $if_echo_type . '
<span class="mp3-label">' . mp_product_price(false, $productbox_post -> ID, false) . '</span><span style="padding-right: 7px;"></span>
</div>'. mp_buy_button(false, 'single', $productid) . '
</div>
</div>
</div>
</div>';
}

add_shortcode('productbox', 'productbox_shortcode');
//<form class="mp_buy_form" action="'. mp_cart_link(false, true) .'" method="post"><input type="hidden" name="product_id" value="' . $productbox_post -> ID . '" /><input type="hidden" name="variation" value="0" /><input type="hidden" name="action" value="mp-update-cart" /><input class="mp_button_addcart" type="submit" name="addcart" value="Add To Cart &raquo;" /></form>

?>